#if !defined ( __OBJECTIVE_FUNCTION__ )
#define        __OBJECTIVE_FUNCTION__

#if !defined ( NULL )
#define NULL 0
#endif

#include "general.h"

class objective_function
{
    public:
        objective_function ( void )
        {
            Dim=0;
            Domain=NULL;
            optimum=NULL;
            outfile=NULL;
            precision=0.0;
            Return_to_domain=0;
            F=NULL;
        };
        virtual ~objective_function ( void )
        {
            int i;
            for ( i=0; i<Dim; i++ ) delete [] Domain[i];
            delete [] Domain;
            delete optimum;
        };
        virtual void create ( void )
        {
        };
        virtual double value ( double *oCH )=0;
        virtual void evaluate ( double *oCH )
        {
        };

        int Dim;
        p_double *Domain;
        double *optimum;
        double precision;
        char *outfile;
        char name[256];
        int Return_to_domain;

        objective_function *F;
};

#endif