/*
 * defs.c		ver. 1.0
 *
 * Definice konstant pro PU
 *
 * M. Leps, 14.1.2000
 *
 */

#include <stdlib.h>
#include <time.h>
#include <math.h>

#include "defs.h"

int rnd_int ( int ovel )
{
  return ( rand()%ovel ) ;
}

int rnd_int_meze ( int olow , int ohigh )
{
    return ( rand()%( ohigh-olow+1 )+olow ) ;
}

int rnd_int_meze ( int olow , int ohigh, int oprecision )
{
  return( (int)floor( round((double)rnd_int_meze( olow , ohigh ),(double)oprecision ))) ;
}

double rnd_real ( void ) 
{
  return (( double )rand()/( double )( RAND_MAX )) ;
}

double rnd_real_meze ( double olow , double ohigh )
{
    return (( double )rand()/( double )( RAND_MAX ))*( ohigh-olow )+olow ;
}

double rnd_real_meze ( double olow , double ohigh, double oprecision )
{
  return( round( rnd_real_meze( olow , ohigh ), oprecision )) ;
}

int probable ( double oa )
{
  if ( rnd_real()<oa ) return 1 ;
  return 0 ;
}

double round ( double oa, double oprecision )
{
  return( ( floor(( oa/oprecision )+0.5 ))*oprecision ) ;
}

double absv ( double ox )
{
    if ( ox<0.0 ) return -ox ;
    return ox ;
}

void init_randoms ( void )
{
  time_t t ;

  t = time( &t ) ;
  //srand48( t ) ;
  srand( t ) ;
}
