/*
 * defs.h		ver. 1.0
 *
 * Definice konstant pro PU
 *
 * M. Leps, 15.11.1999
 *
 */

#ifndef __DEFS__
#define __DEFS__

#include <stdio.h>

#define null          NULL

#define BNo          0
#define BYes         1

#define BFail        0
#define BPass        1

#define No           -1
#define NoInt        -1
#define NoDouble     -7.000770007700077E-177
#define NoChar       0
#define FNameLenght  256

typedef char* p_char ;

/* funkce */

int rnd_int ( int ovel ) ;
int rnd_int_meze ( int olow , int ohigh ) ;
int rnd_int_meze ( int olow , int ohigh, int oprecision ) ;
double rnd_real ( void ) ;
double rnd_real_meze ( double olow , double ohigh ) ;
double rnd_real_meze ( double olow , double ohigh, double oprecision ) ;
int probable ( double oa ) ;
double round ( double oa, double oprecision ) ;

double absv ( double ox ) ; // absolutni hodnota

void init_randoms ( void ) ;

#endif
