/*
 * defs.c		ver. 1.0
 *
 * Definice konstant pro PU
 *
 * M. Leps, 15.11.1999
 *
 */

#include "defs.h"

#include <math.h>

#ifndef RAND_MAX
#define RAND_MAX             32768
#endif

int rnd_int ( int ovel )
{
  return ( rand()%ovel ) ;
}

int rnd_int_meze ( int olow , int ohigh )
{
    return ( rand()%( ohigh-olow+1 )+olow ) ;
}

double rnd_real ( void ) 
{
  return (( double )rand()/( double )( RAND_MAX )) ;
}

double rnd_real_meze ( double olow , double ohigh )
{
    return (( double )rand()/( double )( RAND_MAX ))*( ohigh-olow )+olow ;
}

int probable ( double oa )
{
  if ( rnd_real()<oa ) return 1 ;
  return 0 ;
}

double abs ( double ox )
{
    if ( ox<0.0 ) return -ox ;
    return ox ;
}
