/*
 * defs.h		ver. 1.0
 *
 * Definice konstant pro PU
 *
 * M. Leps, 15.11.1999
 *
 */

#ifndef __DEFS__
#define __DEFS__

/* pointers */
#define null          NULL

/* switch pro optimalizaci */
#define Free          1
#define Lock          0

#define MaxS          0             /* normalni ruleta (vybere nejsilnejsi gen) */
#define MinS          1             /* inverzni ruleta (vybere nejslabsi gen) */

#define Pmutat        0.003          /* pravdepodobnost mutace */

#define Cele          'I'           /* typy prom. */
#define Real          'D'

#define GlobalMax     0             /* co hledam */
#define GlobalMin     1

#define PowerF        0             /* linearni sila */
#define PowerS        1             /* sila dle Kvasnicky */
#define GoldF         2             /* sila dle Goldberga */

#define Bett          0             /* typ reseni */
#define Gold          1

/* files */

#define Read       "rb"
#define Write      "wb"
#define Append     "ab"
#define ReadWrite  "wb+"
#define ReadAppend "ab+"

/* funkce */
#define sqr( x ) x*x

int rnd_int ( int ovel ) ;
int rnd_int_meze ( int olow , int ohigh ) ;

double rnd_real ( void ) ;
double rnd_real_meze ( double olow , double ohigh ) ;

int probable ( double oa ) ;

double abs ( double ox ) ;

#endif
