/*
27.9.
FCE: fswe, Matej, Matrix

Operators:

mutation: RULETA PRO NEJSLABSIHO JEDINCE
mutation2: RULETA PRO NEJSILNEJSIHO JEDINCE
crossing: NAPROSTO NAHODNA, VYTVORI SE DVOJNASOBNA GENERACE
reproduction: TURNAJOVY ZPUSOB, REDUKCE NA PUVODNI POCET GENERACE
cross_extrems: crossing all extrems
               when new chromosom is near some extreme
               and it's better than this extreme,
               it's added into pool, but extreme isn't destroyed

other specialits:

destroy_Extreme: .. if Chromo is near Extremes and Chromo is better than Extreme
mutate: to half of distance between Chromosom and random point in Def_sphere
Penal_rads ...Elipsoid

for programmer:

switching vis:no_vis
              plain
              columns
          fce:fswe
              Matej
              Matrix
*/

#include<math.h>
#include<stdio.h>
#include<memory.h>
#include<stdlib.h>
#include<time.h>

#include <sys/time.h>
#include <unistd.h>

#include <kreslitko.h>
#include "fswe.h"
#include "cmlfile.h"
#include "matrix.h"

// Matej
#include "variable.h"
#include "rc.h"

#define Members 1
#define Dim 18
#define y_0Min 0.0
#define y_0Max 50.0

#define CloseSignal 107

typedef double *p_double;
p_double *Pool;
double Global_best[Dim+1], Best_chromo[Dim+1], Destiny[Dim+1], Radiation,Radiation2, Penal_rads[Dim], Precision;
int n=0,generation=0, Pop,Quiet,Extremes_size,Generation_limit, Fitness_call_limit, fitness_call=0;

int rseed;

#define fswe 1
#define Matej 2
#define Matrix 3

int fce=2;

#define no_vis 0
#define plain 1
#define columns 2

int vis=2;

double cross_rating=0.2;
double mut_rating=0.5;
double discr_rating=0.1;

FILE *f;

kreslitko *K;
fsweM C ;
matrix C3 ;

// Matej


struct extreme
{
    double *location ;
    double own_value ;
    int born_generation ;
    int id ;
} ;

extreme *Extremes;

struct variable
{
    double min, max, range, act_range, prec, act_prec;
    int discr, act_discr;
} ;

variable *Domain;

double Funkce_rc ( double *v )
{
  pr.clear_res() ;

  pr[0].r = v[0] ; // pb->b;
  pr[1].r = v[1] ; //  pb->h;
  pr[2].i = (int) v[2] ; //  pb->pr[DOLNI];
  pr[3].i = (int) v[3] ; //  pb->pr[HORNI];
  pr[4].i = (int) v[4] ; //  pb->m[0].as[DOLNI].n;
  pr[5].i = (int) v[5] ; //  pb->m[1].as[DOLNI].n;
  pr[6].i = (int) v[6] ; //  pb->m[2].as[DOLNI].n;
  pr[7].i = (int) v[7] ; //  pb->m[0].as[HORNI].n;
  pr[8].i = (int) v[8] ; //  pb->m[1].as[HORNI].n;
  pr[9].i = (int) v[9] ; //  pb->m[2].as[HORNI].n;
  pr[10].i = (int) v[10] ; //  pb->m[0].s;
  pr[11].i = (int) v[11] ; //  pb->m[1].s;

  //smyk
  pr[12].i = (int) v[12] ; //  pb->w[0].s;
  pr[13].i = (int) v[13] ; //  pb->w[1].s;
  pr[14].i = (int) v[14] ; //  pb->prw;
  pr[15].r = v[15] ; //  pb->w[0].sw;
  pr[16].r = v[16] ; //  pb->w[1].sw;
  pr[17].r = v[17] ; //  pb->w[2].sw;
  pr[18].i = 2 ; //  pb->w[0].pw;
  pr[19].i = 2 ; //  pb->w[1].pw;
  pr[20].i = 2; //  pb->w[2].pw;
  
  OP_silaGen(  pr, kce->pdb ) ;

  return( 1.0/pr.f ) ;
}

void Tisk_rc ( double *v )
{
  pr.clear_res() ;

  pr[0].r = v[0] ; // pb->b;
  pr[1].r = v[1] ; //  pb->h;
  pr[2].i = (int) v[2] ; //  pb->pr[DOLNI];
  pr[3].i = (int) v[3] ; //  pb->pr[HORNI];
  pr[4].i = (int) v[4] ; //  pb->m[0].as[DOLNI].n;
  pr[5].i = (int) v[5] ; //  pb->m[1].as[DOLNI].n;
  pr[6].i = (int) v[6] ; //  pb->m[2].as[DOLNI].n;
  pr[7].i = (int) v[7] ; //  pb->m[0].as[HORNI].n;
  pr[8].i = (int) v[8] ; //  pb->m[1].as[HORNI].n;
  pr[9].i = (int) v[9] ; //  pb->m[2].as[HORNI].n;
  pr[10].i = (int) v[10] ; //  pb->m[0].s;
  pr[11].i = (int) v[11] ; //  pb->m[1].s;

  //smyk
  pr[12].i = (int) v[12] ; //  pb->w[0].s;
  pr[13].i = (int) v[13] ; //  pb->w[1].s;
  pr[14].i = (int) v[14] ; //  pb->prw;
  pr[15].r = v[15] ; //  pb->w[0].sw;
  pr[16].r = v[16] ; //  pb->w[1].sw;
  pr[17].r = v[17] ; //  pb->w[2].sw;
  pr[18].i = 2 ; //  pb->w[0].pw;
  pr[19].i = 2 ; //  pb->w[1].pw;
  pr[20].i = 2; //  pb->w[2].pw;
  
  OP_silaGen(  pr, kce->pdb ) ;

  TDimBeam bnew;

  nullTDB(&bnew);

  OP_oldtonew( &bnew, kce->pdb, pr);

  TDBdimprn( &bnew );
  TDB_OPprn( &bnew );

}

void initialize_randoms ()
{
    struct timeval tv;
    struct timezone tz;

    gettimeofday( &tv,&tz ) ;

    rseed=tv.tv_usec+( tv.tv_sec%4194304 )*1000 ;
    //rseed=833222291;

    srand( rseed ) ;
}

void load_config ( void )
{
    cmlfile F ;
    switch ( fce )
    {
        case fswe:
            F.open( "config_fswe" ) ;
            break;

        case Matej:
            F.open( "config_Matej" ) ;
            break;

        case Matrix:
            F.open( "config_matrix" ) ;
            break;
    }

    F.set_labels( 10 ) ;
    F.set_label_string( 0,"Mut_rating" ) ;
    F.set_label_string( 1,"Cross_rating" ) ;
    F.set_label_string( 2,"Pop" ) ;
    F.set_label_string( 3,"Extremes_size" ) ;
    F.set_label_string( 4,"Quiet" ) ;
    F.set_label_string( 5,"Radiation" ) ;
    F.set_label_string( 6,"Radiation2" ) ;
    F.set_label_string( 7,"Precision" ) ;
    F.set_label_string( 8,"Generation_limit" ) ;
    F.set_label_string( 9,"Fitness_call_limit" ) ;

    F.get_value( 0,mut_rating );
    F.get_value( 1,cross_rating );
    F.get_value( 2,Pop ) ;
    F.get_value( 3,Extremes_size ) ;
    F.get_value( 4,Quiet ) ;
    F.get_value( 5,Radiation ) ;
    F.get_value( 6,Radiation2 ) ;
    F.get_value( 7,Precision ) ;
    F.get_value( 8,Generation_limit ) ;
    F.get_value( 9,Fitness_call_limit ) ;
}

void load_Domain ( void )
{
    int i,j;

    double q,*var_size,panes=1;

    Domain = new variable [Dim];

    switch ( fce )
    {
        case fswe:
            for ( i=0; i<Dim; i++ )
            {
                Domain[i].min=0.0;
                Domain[i].max=400.0;
                Domain[i].prec=0.0;
            }
            break;

        case Matej:
            //b
            for ( i=0; i<1; i++ )
            {
                Domain[i].min=0.15;
                Domain[i].max=0.45;
                Domain[i].prec=0.025;
            }
            //h
            for ( i=1; i<2; i++ )
            {
                Domain[i].min=0.15;
                Domain[i].max=0.85;
                Domain[i].prec=0.025;
            }
            //horni, dolni pr
            for ( i=2; i<4; i++ )
            {
                Domain[i].min=0.0;
                Domain[i].max=9.0;
                Domain[i].prec=1.0;
            }
            // N
            for ( i=4; i<10; i++ )
            {
                Domain[i].min=0.0;
                Domain[i].max=12.0;
                Domain[i].prec=1.0;
            }
            // Li pro M
            for ( i=10; i<12; i++ )
            {
                Domain[i].min=0.0;
                Domain[i].max=12.0;
                Domain[i].prec=1.0;
            }
            //Prw
            for ( i=14; i<15; i++ )
            {
                Domain[i].min=0.0;
                Domain[i].max=3.0;
                Domain[i].prec=1.0;
            }
            //Li pro W
            for ( i=12; i<14; i++ )
            {
                Domain[i].min=0.0;
                Domain[i].max=12.0;
                Domain[i].prec=1.0;
            }
            //SW
            for ( i=15; i<18; i++ )
            {
                Domain[i].min=0.05;
                Domain[i].max=0.4;
                Domain[i].prec=0.025;
            }
            break;

        case Matrix:
            for ( i=0; i<Dim; i++ )
            {
                Domain[i].min=-200.0;
                Domain[i].max=200.0;
                Domain[i].prec=0.0;
            }
            break;
    }

    var_size = new double [Dim];

    for ( i=0; i<Dim; i++ )
    {
        Domain[i].discr = 0 ;
        Domain[i].act_discr = 0;
        Domain[i].range = Domain[i].max - Domain[i].min ;
        Domain[i].act_range = Domain[i].range;
        if ( Domain[i].prec==0.0 )
        {
            q = log10 ( Domain[i].range );
            q = floor ( q ) - 1 ;
            Domain[i].prec = pow ( 10, -16+q );
        }
        var_size[i] = ( Domain[i].range ) / Domain[i].prec;
        panes *= var_size[i];
        Domain[i].act_prec=Domain[i].prec;
    }
    
    panes/=Pop;

    while ( panes > pow ( 10.0, 35.0 ) )
    {
        j=0;
        for ( i=0; i<Dim; i++ )
        {
            if ( var_size[i] > var_size[j] ) j=i;
        }
        Domain[j].act_prec/=discr_rating;
        Domain[j].discr++;
        Domain[j].act_discr++;
        panes*=discr_rating;
        var_size[j]*=discr_rating;
    }

}

double random_double ( double olow , double ohigh )
{
    return (( double )rand()/RAND_MAX )*( ohigh-olow )+olow ;
}

double random_double ( double between[2] )
{
    return (( double )rand()/RAND_MAX )*( between[1]-between[0] )+between[0] ;
}

int random_int ( int olow , int ohigh )
//vcetne jen dolni meze, horni mimo
{
    return rand()%( ohigh-olow )+olow ;
}

void round_chrm ( double *Chromo, double *Rounded )
{
    int i;

    for ( i=0; i<Dim; i++ )
    {
        Rounded[i] = floor ( Chromo[i]/Domain[i].act_prec+0.5 )*Domain[i].act_prec;
    }
}

void init_graph ( void )
{
    if ( !vis ) return ;

    K = new kreslitko;
    K->create_button( "Close",CloseSignal ) ;

    switch ( vis )
    {
        case plain:
            K->open_graphics( Domain[0].min, Domain[1].min, Domain[0].max, Domain[1].max, 400, 400 ) ;
            break;

        case columns:
            K->open_graphics( 0, 0, Dim+1, 400, 800, 400 ) ;
            break;
    }
}

void draw_peaks ( void )
{
    if ( vis!=plain ) return ;
    if ( fce!=fswe ) return ;

    int i ;
    double x[Dim],z ;

    //C.get_peak( 0,best );

    for ( i=0 ; i<Members ; i++ )
    {
        z=C.get_peak( i,x ) ;
        round_chrm ( x, x );
        K->circle( x[0],x[1],z/5.0 ) ;
        //if ( C.value(best) < C.value(x) ) C.get_peak(i,best);
    }

    //K->circle( best[0],best[1],z/5.0+50 );

    K->is_ready() ;
}

void draw_chromos ( void )
{
    if ( vis!=plain ) return ;
    int i ;

    for ( i=0 ; i<Pop ; i++ )
    {
        K->delete_item( i+1000000 );
    }
    K->redraw();
    for ( i=0 ; i<Pop ; i++ )
    {
        K->cross( Pool[i][0],Pool[i][1],10,i+1000000 ) ;
    }
    K->is_ready() ;
}

void draw_columns ( void )
{
    if ( vis!=columns ) return ;

    int i;

    for ( i=0; i<Dim; i++ )
    {
        K->line( i+1, 40, i+1, 360 );
    }
    K->is_ready();
}

void draw_extreme ( double *Chromo, int id )
{
    switch ( vis )
    {
        case columns:
            int i;

            for ( i=0; i<Dim-1; i++ )
            {
                K->line ( i+1, (Chromo[i]-Domain[i].min)*320/Domain[i].range+40, i+2, (Chromo[i+1]-Domain[i+1].min)*320/Domain[i+1].range+40,100*id+i );
            }
            break;

        case plain:
            K->rectangle ( Chromo[0]-20, Chromo[1]-20, 40, 40, 100*id );
            break;

        default:
            return ;
            break;
    }

    K->is_ready();
}

void draw_extreme ( double *Chromo )
{
    switch ( vis )
    {
        case columns:
            int i;

            for ( i=0; i<Dim-1; i++ )
            {
                K->line ( i+1, (Chromo[i]-Domain[i].min)*320/Domain[i].range+40, i+2, (Chromo[i+1]-Domain[i+1].min)*320/Domain[i+1].range+40 );
            }
            break;

        case plain:
            K->rectangle ( Chromo[0]-20, Chromo[1]-20, 40, 40 );
            break;

        default:
            return ;
            break;
    }

    K->is_ready();
}

void delete_extreme ( int j )
{
    switch ( vis )
    {
        case columns:
            int i;

            for ( i=0; i<Dim-1; i++ )
            {
                K->delete_item ( 100*Extremes[j].id+i );
            }
            break;

        case plain:
            K->delete_item ( 100*Extremes[j].id );
            break;
    }
}

void close_graph ( void )
{
    if ( vis )
    {
        K->wait_for_signal( CloseSignal ) ;
        delete K;
    }
}

void Mutate ( double Chromo[Dim] )
{
    int i;
    double a;

    for ( i=0; i<Dim; i++ )
    {
        a=random_double ( 0, 1);
        if ( a < 1 )
        {
            Chromo[i]=(Chromo[i]+random_double ( Domain[i].min, Domain[i].max ))*mut_rating;
            //Chromo[i]=random_double ( Domain[i].min, Domain[i].max );
        }
    }
}

void destroy_Extreme ( int j )
{
    extreme *recycling;

    printf("destroy0\n");
    recycling = new extreme [n-j-1];
    printf("destroy1\n");
    
    delete_extreme ( j );
    printf("destroy3\n");
    
    memcpy ( recycling, &( Extremes[j+1] ), (n-j-1)*sizeof ( extreme ) );
    printf("destroy4\n");
    delete [] Extremes[j].location;
    Extremes[j].location=NULL ;

    printf("destroy5\n");
    memcpy ( &( Extremes[j] ), recycling, (n-j-1)*sizeof ( extreme ) );
    printf("destroy6\n");
    Extremes[n-1].location=NULL;
    printf("destroy7\n");
    n--;
    printf("destroy8\n");
    
    delete [] recycling;
    printf("destroy9\n");
}

void make_defined ( double *Chromo )
{
    int j;

    for ( j=0; j<Dim; j++ )
    {
        if ( Chromo[j] < Domain[j].min ) Chromo[j]=random_double(Domain[j].min, Domain[j].max);
        if ( Chromo[j] > Domain[j].max ) Chromo[j]=random_double(Domain[j].min, Domain[j].max);
    }
}


double value ( double *Chromo )
{
    double Rounded[Dim];

    make_defined ( Chromo );

    round_chrm ( Chromo, Rounded );

    switch ( fce )
    {
        case fswe:
            return C.value ( Rounded );
            break;

        case Matej:
            return Funkce_rc ( Rounded );
            break;

        case Matrix:
            return C3.value ( Rounded );
            break;
    }
    return 0.0;
}

void get_Penal_rads ( void )
{
    int i;

    for ( i=0; i<Dim; i++ )
    {
        Penal_rads[i] = Domain[i].range/20;
        if ( Penal_rads[i] < Domain[i].prec ) Penal_rads[i]=Domain[i].prec;
    }
}

int need_penalize ( double *Chromo, double chr_value )
{
    int i,j;
    double x;

    for ( i=0; i<n; i++ )
    {
        x=0;
        for ( j=0; j<Dim; j++ )
        {
            x += pow ( (Chromo[j]-Extremes[i].location[j]) / Penal_rads[j], 2 ) ;
        }
        if ( x < 1 )
        {
            if ( chr_value > Extremes[i].own_value )
            {
                destroy_Extreme ( i );
                printf("G=%d Vypnuta penalizacni funkce%d\n",generation,i+1);
                i--;
            }
            else return 1;
        }
    }
    return 0;
}

double fitness ( double *Chromo )
{
    double chr_value;

    fitness_call++;

    chr_value = value( Chromo );

    while ( need_penalize ( Chromo, chr_value ) )
    {
        Mutate ( Chromo );
        chr_value = value ( Chromo );
        //penale *= 2 * atan ( sqrt ( sqrdistance*sqrdistance/100.0 ) ) / M_PI;
        //penale *= 1.0 - exp( -sqrdistance/1000 ) ;
    }

    if ( ( fce==Matej ) && ( chr_value > 1.7 ) ) draw_extreme ( Chromo );

    return chr_value ;
}   
void start_generation ( void )
{
    int i,j;

    get_Penal_rads ();

    Pool=new p_double[2*Pop];
    for (i=0;i<2*Pop;i++) Pool[i]=new double [Dim+1];
    for (i=0;i<2*Pop;i++) 
    {
        for (j=0;j<Dim;j++) 
        {
            Pool[i][j]=random_double(Domain[j].min, Domain[j].max);
        }
        Pool[i][Dim]=fitness(Pool[i]);
    }
    Global_best[Dim]=0;
    Best_chromo[Dim]=0;
    Extremes = new extreme [Extremes_size];
}

void Just_mutate ( void )
{
    int i;

    for ( i=0; i<Pop; i++ )
    {
        Mutate ( Pool[i] );
        Pool[i][Dim] = fitness ( Pool[i] );
    }
}

void reproduction ( void )
{
    int a,b,c,i;
    double *u;

    for (i=0;i<Pop;i++)
    {
        a=random_int(0,2*Pop-i);
        b=random_int(0,2*Pop-i);
        if (Pool[a][Dim]>=Pool[b][Dim])
        {
            c=b;
        }
        else
        {
            c=a;
        }
        
        u=Pool[2*Pop-i-1];
        Pool[2*Pop-i-1]=Pool[c];
        Pool[c]=u;
    }
}

void crossing ( void )
{
    int i,j,k; 
    double *Mom,*Papa;

    for (i=0;i<Pop;i++)
    {
        j=random_int(0,Pop);
        Mom=Pool[j];

        j=random_int(0,Pop);
        Papa=Pool[j];
        
        j=random_int(0,Pop);
        for (k=0;k<Dim;k++) Pool[Pop+i][k] = Pool[j][k] + cross_rating*(Mom[k] - Papa[k]);
        Pool[Pop+i][Dim] = fitness ( Pool[Pop+i] );
    }
}

void cross_extremes ( void )
{
    int i,j,k=0,a,b,c;
    double *Mom,*Papa,*Baby,*u;

    Baby = new double [Dim+1];

    for (i=0;i<n;i++)
    {
        j=random_int(0,Pop);
        Mom=Pool[j];

        j=random_int(0,Pop);
        Papa=Pool[j];
        
        for (j=0;j<Dim;j++) Baby[j] = Extremes[i].location[j] + cross_rating*(Mom[j] - Papa[j]);
        make_defined ( Baby );
        Baby[Dim] = value ( Baby );
        if ( Baby[Dim] > Extremes[i].own_value )
        {
            k++;
            memcpy( Pool[Pop+k], Baby, (Dim+1)*sizeof ( double ) );
            //destroy_Extreme ( i );
            //i--;
        }
    }

    delete [] Baby;

    for ( i=0; i<k; i++ )
    {
         a=random_int(0,Pop+k-i);
         b=random_int(0,Pop+k-i);
         if (Pool[a][Dim]>=Pool[b][Dim]) c=b;
         else c=a;
 
         u=Pool[Pop+k-i];
         Pool[Pop+k-i]=Pool[c];
         Pool[c]=u;
    }

}

void mutation ( void )
{
    int i,j;
    double a,Moving=0,Aktual_sum_of_fitness=0,Sum_of_fitness=0,ruleta[Pop];

    //for (i=0;i<Pop;i++) 
    //if (fitness(Pool[i]) < (-Moving)) Moving = (-fitness(Pool[i])); 

    for (i=0;i<Pop;i++) Sum_of_fitness += 1 / ( Moving + Pool[i][Dim] );

    for (i=0;i<Pop-1;i++) 
    {
        Aktual_sum_of_fitness += 1 / ( Moving + Pool[i][Dim] );
	ruleta[i] =  Aktual_sum_of_fitness  / Sum_of_fitness;
    }
        
    ruleta[Pop-1]=1.0;

    for (i=0;i<Pop;i++)
    {
        a=random_double (0,1);
	if (a <= Radiation) 
        {
            a=random_double (0,1);
	    j=0;
            while (ruleta[j]<a) j++;
            Mutate ( Pool[j] );
	    Pool[j][Dim] = fitness ( Pool[j] );
	}
    }
}

void mutation2 ( void )
{
    int i,j,k;
    double a,Mutagen, Moving=0,Aktual_sum_of_fitness=0,Sum_of_fitness,ruleta[Pop];

    //for (i=0;i<Pop;i++) 
    //  if (fitness(Pool[i]) < (-Moving)) Moving = (-fitness(Pool[i]));

    Sum_of_fitness = Pop * Moving ;
    for (i=0;i<Pop;i++) Sum_of_fitness += Pool[i][Dim];

    for (i=0;i<Pop-1;i++)
    {
        Aktual_sum_of_fitness += Moving + Pool[i][Dim];
	ruleta[i] = Aktual_sum_of_fitness / Sum_of_fitness;
    }
    ruleta[Pop-1]=1;

    for (i=0;i<Pop;i++)
    {
        a=random_double (0,1);
        if (a <= Radiation2)
        {
            a=random_double (0,1);
	    j=0;
	    while (ruleta[j]<a) j++;
            for ( k=0; k<Dim; k++ )
            {
                Mutagen=Domain[k].act_prec;
                Pool[j][k]+=random_double ( -Mutagen,Mutagen );
            }
            Pool[j][Dim] = fitness ( Pool[j] );
        }
    }
}

void control ( void )
{
    int i,j;
    static int id=0, k=1, lastchange=0;

    double mins[Dim], maxs[Dim];

    for ( i=0; i<Dim; i++ )
    {
        mins[i]=Pool[0][i];
        maxs[i]=Pool[0][i];
    }

    for (i=0;i<Pop;i++)
    {
        if ( Best_chromo[Dim] < Pool[i][Dim] )
        {
            memcpy( Best_chromo, Pool[i], (Dim+1)*sizeof(double) );
	    lastchange=fitness_call;
            //fprintf( f, "Generace: %d Reseni: (%f,%f) Hodnota %16.16E.\n",generation,Best_chromo[0],Best_chromo[1],Best_chromo[Dim] );
            //printf ( "generace: %d Reseni: (%f,%f) Hodnota %16.16E.\n",generation,Best_chromo[0],Best_chromo[1],Best_chromo[Dim] );
            fprintf( f, "Fitness_call: %d Reseni: (%f,%f) Hodnota %16.16E.\n",fitness_call,Best_chromo[0],Best_chromo[1],Best_chromo[Dim] );
            //printf ( "fitness_call: %d Reseni: (%f,%f) Hodnota %16.16E.\n",fitness_call,Best_chromo[0],Best_chromo[1],Best_chromo[Dim] );
            
            if ( Best_chromo[Dim] > Global_best[Dim] )
            {
                memcpy ( Global_best, Best_chromo, ( Dim+1 )*sizeof ( double ) );
                printf ( "**Best: %f\n", Global_best[Dim] );
            }
        }
        for ( j=0; j<Dim; j++ )
        {
            if ( Pool[i][j] < mins[j] ) mins[j]=Pool[i][j];
            if ( Pool[i][j] > maxs[j] ) maxs[j]=Pool[i][j];
        }
    }

    int x=0;
    for ( i=0; i<Dim; i++ )
    {
        x+=Domain[i].act_discr;
        //printf("Domain[%d].act_range=%f\n",i,Domain[i].act_range);
        //printf("maxs[%d]-mins[%d]=%f\n",i,i,maxs[i]-mins[i]);
    }
    //printf("x=%d\n",x);

    for ( i=0; i<Dim; i++ )
    {
        while ( ( Domain[i].act_range*discr_rating > ( maxs[i] - mins[i] ) )&&( Domain[i].act_discr>0 ) )
        {
            Domain[i].act_prec*=discr_rating;
            Domain[i].act_range*=discr_rating;
            Domain[i].act_discr--;
        }
    }
    
    if ( fitness_call-lastchange>Quiet*Dim )
    {
        printf("%d\n",lastchange );
        Extremes[n].location=new double [Dim];
        memcpy ( Extremes[n].location, Best_chromo, (Dim)*sizeof(double) );
        Extremes[n].own_value=Best_chromo[Dim];
        Extremes[n].id=id;
        Extremes[n].born_generation=generation;
        draw_extreme ( Extremes[n].location, Extremes[n].id );
        id++;
        n++;
        lastchange=fitness_call;
        fprintf ( f, "G=%d Zapnuta penalizacni funkce%d\n", generation,n );
        printf ( "G=%d Zapnuta penalizacni funkce%d\n", generation,n );
        Just_mutate();
        Best_chromo[Dim]=0;
        for ( i=0; i<Dim; i++ )
        {
            Domain[i].act_range=Domain[i].range;
            Domain[i].act_prec=pow( 2, Domain[i].discr);
            Domain[i].act_discr=Domain[i].discr;
        }
    }

    if ( generation==k*50 )
    {
        printf("generation:%d\n",generation);
        k++;
    }
}

void openfile ( void )
{
    int id;
    char file[32];
    
    f = fopen ( "calculater", "rt" );
    fscanf( f, "%d", &id );
    fclose ( f );

    f = fopen ( "calculater", "wt" );
    id++;
    fprintf( f, "%d", id );
    fclose ( f );
    
    sprintf( file,"out%d",id ) ;
    f = fopen ( file, "wt" );

    fprintf ( f, "rseed=%d\n",rseed );
}

void print_results ( void )
{
    int i,j;

    fprintf ( f, "Nalezena mozna reseni:\n");
    printf ( "Nalezena mozna reseni:\n");
    for ( i=0; i<n; i++ ) 
    {
        printf ( "( %f", Extremes[i].location[0] );
	for ( j=1; j<Dim; j++ ) printf ( ", %f", Extremes[i].location[j] );
        printf ( " ) z=%f\n",Extremes[i].own_value );

        fprintf ( f, "( %f", Extremes[i].location[0] );
	for ( j=1; j<Dim; j++ ) fprintf ( f, ", %f", Extremes[i].location[j] );
        fprintf ( f, " ) z=%f\n", Extremes[i].own_value );

	if ( Best_chromo[Dim] < Extremes[i].own_value )
        {
            memcpy ( Best_chromo, Extremes[i].location, (Dim)*sizeof ( double ) );
            Best_chromo[Dim] = Extremes[i].own_value;
	}
    }

    fprintf ( f, "Nejlepsi reseni:\n( %f", Global_best[0] );
    for ( i=1; i<Dim; i++ ) fprintf ( f, ", %f", Global_best[i] );
    fprintf ( f, " ) z=%f\n",Global_best[Dim] );

    printf ( "Nejlepsi reseni:\n( %f", Global_best[0] );
    for ( i=1; i<Dim; i++ ) printf ( ", %f", Global_best[i] );
    printf ( " ) z=%f\n", Global_best[Dim] );

    switch ( fce )
    {
        case fswe:
            printf ( "Destiny:\n( %f", Destiny[0] );
            for ( i=1; i<Dim; i++ ) printf ( ", %f", Destiny[i] );
            printf ( " ) z=%f\n", Destiny[Dim] );

            fprintf ( f, "Destiny:\n( %f", Destiny[0] );
            for ( i=1; i<Dim; i++ ) fprintf ( f, ", %f", Destiny[i] );
            fprintf ( f, " ) z=%f\n", Destiny[Dim] );
            break;

        case Matrix:
            C3.printself () ;
            C3.printself ( f ) ;
            C3.print_solution ( Destiny ) ;
            C3.print_solution ( Destiny, f ) ;
            break;
    }

    fprintf ( f, "fitness_call: %d\n", fitness_call );
    printf ( "fitness_call: %d\n", fitness_call );

    fclose ( f );
}

void destroy_all ( void )
{
    int i;

    delete [] Domain;

    for ( i=0; i<n; i++ ) delete [] Extremes[i].location;
    delete [] Extremes;

    for ( i=0; i<2*Pop; i++ ) delete [] Pool[i];
    delete [] Pool;
}

void statistics ( void )
{
    fopen ( "results", "at" );
    switch ( fce )
    {
        case fswe:
            fprintf ( f, "%d\n", generation );
            break;

        case Matej:
            fprintf ( f, "%f\n", Global_best[Dim] );
            break;

        case Matrix:
            fprintf ( f, "%f\n", Global_best[Dim] );
            break;
    }
    fclose ( f );
}

void get_Destiny ( double *Destiny )
{
    int i,j;
    double peak[Dim],max_value=0;

    for ( i=0; i<Members; i++ )
    {
        C.get_peak( i, peak );

        round_chrm ( peak, peak );

        if ( max_value < C.value ( peak ) )
        {
            max_value = C.value ( peak );
            j=i;
        }
    }

    C.get_peak ( j, Destiny );
    round_chrm ( Destiny, Destiny );
    Destiny[Dim]=max_value;

    fprintf ( f, "Destiny( %f", Destiny[0] );
    for ( i=1; i<Dim; i++ ) fprintf ( f, ", %f", Destiny[i] );
    fprintf ( f, " ) z=%f\n",Destiny[Dim] );
}

main ( void )
{
    int i;

    initialize_randoms ();

    load_config ();
    load_Domain ();
    
    openfile ();
    
    switch ( fce )
    {
        case Matej:
            // inicializace promenne
            pr.prepare( 21 ) ;

            // inicializace pomocneho nosniku
            TDimBeam *beam;
            beam=alokaceTDB(1) ;

            // inicializace cele konstrukce
            kce=TSKload( "test4.in" ) ;
            dimenzace( kce ) ;
            break;

        case fswe:
            C.create( Members,Dim );
            for ( i=0; i<Dim; i++ )
            {
                C.set_limits( i, Domain[i].min, Domain[i].max );
            }
            C.set_peak_limits( y_0Min,y_0Max ) ;
            C.print_all_peaks ();
            C.print_all_peaks( f ) ;
            
            get_Destiny( Destiny );
            break;

        case Matrix:
            C3.create ( Dim );
            C3.get_solution ( Destiny );
            Destiny[Dim] = C3.value ( Destiny ) ;
            C3.printself () ;
            C3.printself ( f ) ;
            C3.print_solution ( Destiny ) ;
            C3.print_solution ( Destiny, f ) ;
            break;
    }
    
    init_graph() ;
    draw_peaks() ;

    draw_columns ();

    start_generation ();
        
    reproduction ();
        
    control ();
    
    //while ( generation < Generation_limit )  
    while ( fitness_call < Fitness_call_limit )
    {
        mutation ();
        //printf("mut\n");
        mutation2 ();
        //printf("mut2\n");
        crossing ();
        //printf("cross\n");
        reproduction ();
        //printf("repro\n");
        cross_extremes ();
        //printf("cross_ex\n");
        draw_chromos() ;
        //printf("draw\n");
        control();
        //printf("control\n");
        generation++;
    }

    if ( fce==fswe )
    {
        C.print_all_peaks() ;
        C.print_all_peaks(f) ;
    }

    print_results();

    if ( fce==Matrix ) C3.get_solution ( Destiny );

    if ( fce==Matej ) Tisk_rc ( Global_best );

    statistics ();

    close_graph () ;

    destroy_all ();
}