#if !defined ( __OBJECTIVE_FUNCTION__ )
#include "function.h"
#endif
#include "puc/share.h"
#include "puc/K.h"

#define P_maxx     177.27 /* x dimesion of reference media */
#define P_maxy     130.   /* y dimesion of reference media */
#define num_templ  5      /* Number of points on measuring template */
#define num_newfib 10     /* Number of fibers in optimized configuration */

class puc : public objective_function
{
    public:
        puc ( void );
        ~puc ( void );
        double value ( double *oCH );
    private:
        KPARAMS *par;     /* Function parameters */
        double  *K_ref;   /* Value of K function for reference media */
        double  *K_akt;   /* Value of K function for current configuration */
};

