/*
 * variable.cpp
 *
 * Definice  promenne
 * nezavisle na optimalizacnim algoritmu
 *
 * M. Leps, 15.09.2000
 *
 */

#include <stdlib.h>
#include <string.h>

#include "variable.h"

/**************************************************************************
 *
 * Variables Population * 
 *
 **************************************************************************/
PopVar::PopVar ( void )
{
	nv=0 ;
	var=null ;
}

PopVar::~PopVar ( void )
{
	if( var ) delete [] var ;
}

void PopVar::prepare( int on )
{
	nv=on ;
	var=new Variable[on] ;
	clear_res() ;
}

void PopVar::clear_res( void )
{
	chi=0.0 ;
	f=0.0 ;
	net_f=0.0 ;
	cena=0.0 ;
	change=BNo ;
	penalt=BNo ;
}

void PopVar::copy( PopVar &op )
{
	chi=op.chi ;
	f=op.f ;
	net_f=op.net_f ;
	cena=op.cena ;
	change=op.change ;
	penalt=op.penalt ;

  if( var )
    memcpy( var , op.var , nv*sizeof( Variable )) ;
}

Variable &PopVar::operator [] ( int oi )
{
	return( var[oi] ) ;
}

