/*
 * variable.h
 *
 * Deklarace promenne
 * nezavisle na optimalizacnim algoritmu
 *
 * M. Leps, 15.09.2000
 *
 */

#ifndef __VARIABLE_H__
#define __VARIABLE_H__

#include "id.h"
#include "defs.h"

union Variable
{
  int i ;
  double r ;
} ;

typedef Variable* p_Var ;

class PopVar : public ClassType
{
    public:
      DefineClass ( CPopVar , GBasic ) ;
    public:
      PopVar ( void ) ;
      virtual ~PopVar ( void ) ;
	    void prepare( int on );
	    void clear_res ( void ) ;
	    void copy ( PopVar &op ) ;
      Variable &operator [] ( int oi ) ;
    public:
		  double f ;                    // celkova funkce
		  double net_f ;                // funkce bez penalt
		  double chi ;                  // penalty
		  double cena ;                 // pripadna dalsi hodnota
		  int penalt ;                  // zda je penalta
		  int change ;                  // zmena Variable funkci
    public:
      Variable *var ;
      int nv ;
} ;

#endif
