#ifndef _K_
#define _K_

typedef struct{
 double x;
 double y;
} POINT;

typedef struct{
  POINT *fib;           /* Location of fiber centers */
  unsigned num_fibers;  /* Number of fibers */
  double r;             /* Radius of fibers */
  double *r_meas;       /* Measuring distances */
  unsigned num_meas;    /* Number of measuring distances */
  POINT P_max;          /* Position of right upper corner of sampling window */
} KPARAMS;

void K ( double *k, KPARAMS *params );

#endif 
